package com.perdemia.permissionanalyzer.application.export;

import java.util.List;

import com.perdemia.permissionanalyzer.application.jface.dialogs.ReportDialog;
import com.perdemia.permissionanalyzer.data.Filter;
import com.perdemia.permissionanalyzer.data.FilterSet;

/**
 * Serves as input for the {@link ReportDialog#filterTreeViewer}. It represents the Filters and FilterSets for the selected report.
 * 
 * @author Reinier
 *
 */
public class ReportFilters {
	/** List of available FilterSets in the GUI */
	private FilterSet memberFilterSet;
	private FilterSet permissionFilterSet;
	private FilterSet folderFilterSet;
	
	/** List of Filters that belong to the report */
	private List<Filter> memberFilters;
	private List<Filter> permissionFilters;
	private List<Filter> folderFilters;
	
	/** Indicates the values of the checkboxes of FilterSets in the GUI */
	private boolean linkToMemberFilterSet;
	private boolean linkToPermissionFilterSet;
	private boolean linkToFolderFilterSet;
	
	public FilterSet getMemberFilterSet() {
		return memberFilterSet;
	}
	public void setMemberFilterSet(FilterSet memberFilterSet) {
		this.memberFilterSet = memberFilterSet;
	}
	public FilterSet getPermissionFilterSet() {
		return permissionFilterSet;
	}
	public void setPermissionFilterSet(FilterSet permissionFilterSet) {
		this.permissionFilterSet = permissionFilterSet;
	}
	public FilterSet getFolderFilterSet() {
		return folderFilterSet;
	}
	public void setFolderFilterSet(FilterSet folderFilterSet) {
		this.folderFilterSet = folderFilterSet;
	}
	public List<Filter> getMemberFilters() {
		return memberFilters;
	}
	public void setMemberFilters(List<Filter> memberFilters) {
		this.memberFilters = memberFilters;
	}
	public List<Filter> getPermissionFilters() {
		return permissionFilters;
	}
	public void setPermissionFilters(List<Filter> permissionFilters) {
		this.permissionFilters = permissionFilters;
	}
	public List<Filter> getFolderFilters() {
		return folderFilters;
	}
	public void setFolderFilters(List<Filter> folderFilters) {
		this.folderFilters = folderFilters;
	}
	public boolean isLinkToMemberFilterSet() {
		return linkToMemberFilterSet;
	}
	public void setLinkToMemberFilterSet(boolean linkToMemberFilterSet) {
		this.linkToMemberFilterSet = linkToMemberFilterSet;
	}
	public boolean isLinkToPermissionFilterSet() {
		return linkToPermissionFilterSet;
	}
	public void setLinkToPermissionFilterSet(boolean linkToPermissionFilterSet) {
		this.linkToPermissionFilterSet = linkToPermissionFilterSet;
	}
	public boolean isLinkToFolderFilterSet() {
		return linkToFolderFilterSet;
	}
	public void setLinkToFolderFilterSet(boolean linkToFolderFilterSet) {
		this.linkToFolderFilterSet = linkToFolderFilterSet;
	}
}
