package com.perdemia.permissionanalyzer.application.handlers.menu;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.perdemia.permissionanalyzer.application.jface.dialogs.ContactSupportDialog;
import com.perdemia.permissionanalyzer.application.jface.dialogs.SyncMessageDialog;
import com.perdemia.permissionanalyzer.application.preferences.PreferenceHelper;

public class EmailSupportHandler {
	private final static Logger logger = LoggerFactory.getLogger(EmailSupportHandler.class.getName());
		
	@Execute
	public void execute(Shell shell){
		if (PreferenceHelper.getInstance().getSmtpHost().isEmpty()) {
			SyncMessageDialog.showMessage(MessageDialog.ERROR, "No SMTP server configured", "Please configure a SMTP server in the preferences before using the contact form.");
			logger.error("No SMTP server configured!");
			return;
		}
		
		new ContactSupportDialog(shell).open();
	}

}
