package com.perdemia.permissionanalyzer.application.handlers.menu;

import com.perdemia.permissionanalyzer.application.jface.dialogs.PreferenceDialog;
import com.perdemia.permissionanalyzer.application.preferences.PreferenceHelper;
import com.perdemia.permissionanalyzer.data.util.DBUtil;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.widgets.Shell;

public class OpenPreferencesHandler {

	@Execute
	public void execute(Shell shell){
		PreferenceDialog dialog = new PreferenceDialog(shell);
    	
    	if (dialog.open() == IDialogConstants.OK_ID) {
    		PreferenceHelper prefs = PreferenceHelper.getInstance();
    		prefs.setLdapConnectionsList(dialog.getLdapConnectionsList());
    		prefs.setProxyHost(dialog.getProxyHost());
    		prefs.setProxyPort(dialog.getProxyPort());
    		prefs.setProxyUsername(dialog.getProxyUsername());
    		prefs.setProxyPassword(dialog.getProxyPassword());
    		prefs.setUseSystemProxy(dialog.isUseSystemProxy());
    		prefs.setSmtpHost(dialog.getSmtpHost());
    		prefs.setSmtpPort(dialog.getSmtpPort());
    		prefs.setSmtpType(dialog.getSmtpType());
    		prefs.setSmtpUsername(dialog.getSmtpUsername());
    		prefs.setSmtpPassword(dialog.getSmtpPassword());
    		prefs.setSmtpFrom(dialog.getSmtpFrom());
    		prefs.setSmtpAttachReports(dialog.isSmtpAttachReports());
    		prefs.setReportEmailTemplate(dialog.getReportEmailTemplate());
    		prefs.setPolicyEmailTemplate(dialog.getPolicyEmailTemplate());
    		prefs.setReportEmailSubject(dialog.getReportEmailSubject());
    		prefs.setPolicyEmailSubject(dialog.getPolicyEmailSubject());
    		prefs.setCheckForUpdates(dialog.isCheckForUpdates());
    		prefs.setMasterPassword(dialog.getApplicationPassword());
    		prefs.setEncryptDatabase(dialog.isEncryptDatabase());
    		prefs.setLogLevels(dialog.getLogLevels());
    		prefs.setLdapAccountNameAttribute(dialog.getLdapAccountNameAttribute());
    		prefs.setLdapUserDisplayNameAttribute(dialog.getLdapUserDisplayNameAttribute());
    		prefs.setLdapGroupDisplayNameAttribute(dialog.getLdapGroupDisplayNameAttribute());
    		prefs.setLdapGroupTypeAttribute(dialog.getLdapGroupTypeAttribute());
    		prefs.setLdapDNAttribute(dialog.getLdapDNAttribute());
    		prefs.setLdapPrimaryGroupIdAttribute(dialog.getLdapPrimaryGroupIdAttribute());
    		prefs.setLdapGroupMemberAttribute(dialog.getLdapGroupMemberAttribute());
    		prefs.setLdapMemberOfAttribute(dialog.getLdapMemberOfAttribute());
    		prefs.setDebugLdap(dialog.isDebugLdap());
    		prefs.setFollowReferrals(dialog.isFollowReferrals());
    		prefs.setDbConnectionType(dialog.getDbConnectionType());
    		prefs.setDbConnectionString(dialog.getDbConnectionString());
    		prefs.setDbConnectionDriver(dialog.getDbConnectionDriver());
    		prefs.setDbConnectionUsername(dialog.getDbConnectionUsername());
    		prefs.setDbConnectionPassword(dialog.getDbConnectionPassword());
    		prefs.setBatchSizeFiles(dialog.getBatchSizeFiles());
    		prefs.setBatchSizeAces(dialog.getBatchSizeAces());
    		prefs.setBatchSizeMembers(dialog.getBatchSizeMembers());
    		prefs.setBatchSizeMemberships(dialog.getBatchSizeMemberships());
    		prefs.setCalculateOwnershipRatioInOverview(dialog.isCalculateOwnershipRatioInOverview());
    		prefs.setCalculateOwnershipRatioInEffectivePermissionsTab(dialog.isCalculateOwnershipRatioInEffectivePermissionsTab());
    		prefs.setLogoFileName(dialog.getLogoFileName());
    		prefs.setLogoBase64(dialog.getLogoBase64());
    		prefs.setLogoWidth(dialog.getLogoWidth());
    		prefs.setLogoHeight(dialog.getLogoHeight());
    		prefs.setLogoLocationRight(dialog.getLogoLocationRight());
    		prefs.setLogoLocationTop(dialog.getLogoLocationTop());
    		prefs.setCsvSeparator(dialog.getCsvSeparator());
    		prefs.setMaxFileExportMegaBytes(dialog.getMaxFileExportMegaBytes());
    		prefs.setUseUserDisplayNameInReport(dialog.isUseUserDisplayNameInReport());
    		
    		prefs.storePreferences(true);
    		
    		// reset DB connection
    		DBUtil.closeDBConnection();
    	}
	}
}
