package com.perdemia.permissionanalyzer.application.handlers.menu;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.MElementContainer;
import org.eclipse.e4.ui.model.application.ui.MUIElement;
import org.eclipse.e4.ui.model.application.ui.advanced.MPerspective;
import org.eclipse.e4.ui.model.application.ui.advanced.MPerspectiveStack;
import org.eclipse.e4.ui.model.application.ui.basic.MWindow;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

public class ResetPerspectiveHandler {
	private static final String MAIN_PERSPECTIVE_STACK_ID = "com.perdemia.permissionanalyzer.application.perspectivestack";

	/*
	@Execute
	public void execute(EModelService modelService, MApplication application) {
		MPerspectiveStack perspectiveStack = (MPerspectiveStack) modelService
				.find(MAIN_PERSPECTIVE_STACK_ID, application);
		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage()
				.resetPerspective();
		perspectiveStack.getSelectedElement().setVisible(true);
		perspectiveStack.setVisible(true);
	}*/

	@Execute
	public void execute(@Named(IServiceConstants.ACTIVE_SHELL) Shell shell, EModelService modelService, MApplication app, EPartService partService) {

		MWindow window = (MWindow) modelService.find("com.perdemia.permissionanalyzer.application.window", app);

		final MPerspective perspective = modelService.getActivePerspective(window);
		final MUIElement snippet = modelService.cloneSnippet(app, perspective.getElementId(), window);
		
		snippet.setToBeRendered(true);
		if (snippet != null) {
			MElementContainer<MUIElement> parent = perspective.getParent();
			perspective.setToBeRendered(false);

			List<MWindow> existingDetachedWindows = new ArrayList<MWindow>();
			existingDetachedWindows.addAll(perspective.getWindows());

			MPerspective dummyPerspective = (MPerspective) snippet;
			while (dummyPerspective.getWindows().size() > 0) {
				MWindow detachedWindow = dummyPerspective.getWindows().remove(0);
				perspective.getWindows().add(detachedWindow);
			}

			parent.getChildren().remove(perspective);
			parent.getChildren().add(snippet);
			partService.switchPerspective((MPerspective) snippet);
		}
	}
}
