package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.jface.viewers.AbstractTreeViewer;
import org.eclipse.jface.viewers.ITreeSelection;

import com.perdemia.permissionanalyzer.application.parts.FilePart;
import com.perdemia.permissionanalyzer.application.util.ApplicationUtil;

public class CollapseAllHandler {
	
	@Execute
	public void execute(MApplication app, EPartService partService, EModelService modelService){
		MPart part = partService.findPart(FilePart.ID);
		FilePart fileTreePart = (FilePart) part.getObject();
		
		ApplicationUtil.setBusyCursor();
		fileTreePart.getTreeViewer().getTree().setRedraw(false);
		try{
			if (fileTreePart.getTreeViewer().getTree().getSelection().length > 0) {
				fileTreePart.getTreeViewer().collapseToLevel(((ITreeSelection)fileTreePart.getTreeViewer().getSelection()).getFirstElement(), AbstractTreeViewer.ALL_LEVELS);;
			}
		} finally {
			fileTreePart.getTreeViewer().getTree().setRedraw(true);
			ApplicationUtil.setDefaultCursor();
		}		
	}
	
	@CanExecute
	public boolean canExecute(EPartService partService){
		MPart part = partService.findPart(FilePart.ID);
		FilePart fileTreePart = (FilePart) part.getObject();
		return fileTreePart.getTreeViewer().getTree().isVisible();
	}
}
