package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.perdemia.permissionanalyzer.application.preferences.PreferenceHelper;

public class HideModifyACEHandler {
	private static final Logger logger = LoggerFactory.getLogger(HideModifyACEHandler.class.getName());
	
	@Execute
	public void execute(Shell shell, MPart viewpart){
		PreferenceHelper prefs = PreferenceHelper.getInstance();
		
		boolean hideModifyAce = !prefs.isHideModifyAce();
		
		logger.info("Setting preference to hide modify ACE buttons: " + hideModifyAce);
		
		prefs.setHideModifyAce(hideModifyAce);
		prefs.storePreferences(false);
		
		if (hideModifyAce) {
			MessageDialog.openInformation(null, "Modify ACE", "The buttons to modify an ACE have been hidden. Restart the application to apply the change.");
		} else {
			MessageDialog.openInformation(null, "Modify ACE", "The buttons to modify an ACE will be made visible again after the application has been restarted.");
		}
	}
}
