 
package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import com.perdemia.permissionanalyzer.application.util.FilterHelper;

import org.eclipse.core.commands.ParameterizedCommand;
import org.eclipse.e4.core.commands.ECommandService;
import org.eclipse.e4.core.commands.EHandlerService;
import org.eclipse.e4.core.di.annotations.Execute;

public class QuickFileSearchHandler {
	@SuppressWarnings("restriction")
	@Execute
	public void execute(final ECommandService commandService, final EHandlerService handlerService) {
		// apply the quick search parameter in the FilterHelper
		FilterHelper.getInstance().setQuickFileSearch(FilterHelper.getInstance().getQuickFileSearchText().getText());
		
		// first trigger the refresh command
		ParameterizedCommand applyFilterCommand = commandService.createCommand("com.perdemia.permissionanalyzer.application.commands.applyfilter", null);
		handlerService.executeHandler(applyFilterCommand);
		
		// expand all
		if (FilterHelper.getInstance().getQuickFileSearch().length() > 0) {
			ParameterizedCommand expandAllCommand = commandService.createCommand("com.perdemia.permissionanalyzer.application.commands.expandall", null);
			handlerService.executeHandler(expandAllCommand);
		}
		
		// clear the quick search value, we don't want to use the value when the user creates a new overview by pressing Apply Filter
		FilterHelper.getInstance().setQuickFileSearch("");
	}		
}