package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import com.perdemia.permissionanalyzer.application.parts.FilterFolderPart;
import com.perdemia.permissionanalyzer.application.parts.FilterMemberPart;
import com.perdemia.permissionanalyzer.application.parts.FilterPermissionPart;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.ESelectionService;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ResetFilterHandler {
	private static final Logger logger = LoggerFactory.getLogger(ResetFilterHandler.class.getName());
	
	@Execute
	public void execute(MApplication app, EPartService partService, EModelService modelService, final ESelectionService selectionService){
		if (MessageDialog.openConfirm(Display.getCurrent().getActiveShell(), "Reset filters", "Are you sure you want to reset all filters to their default value?")) {
			MPart part = partService.findPart(FilterMemberPart.ID);
			FilterMemberPart filterMemberPart = (FilterMemberPart) part.getObject();
			if (filterMemberPart != null) {
				filterMemberPart.resetFilters();
			}
			
			part = partService.findPart(FilterPermissionPart.ID);
			FilterPermissionPart filterPermissionPart = (FilterPermissionPart) part.getObject();
			if (filterPermissionPart != null) {
				filterPermissionPart.resetFilters();
			}
			
			part = partService.findPart(FilterFolderPart.ID);
			FilterFolderPart filterFolderPart = (FilterFolderPart) part.getObject();
			if (filterFolderPart != null) {
				filterFolderPart.resetFilters();
			}
		}
	}
}
