package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import javax.annotation.PostConstruct;

import com.perdemia.permissionanalyzer.application.parts.FilePart;
import com.perdemia.permissionanalyzer.application.util.ImageFactory;
import com.perdemia.permissionanalyzer.application.util.ImageFactory.AppImage;

import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.ESelectionService;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class TraceHideInheritedToolControl {
	private boolean checked = false;
	
	@PostConstruct
	public void createGui(final Composite parent, final EPartService partService, final ESelectionService selectionService) {		
		final Button button = new Button(parent, SWT.CHECK);
		button.setText("Hide inherited permissions");
		button.setImage(ImageFactory.getInstance().getImage(AppImage.BROWSE_16X16));
		button.setSelection(false);		
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				checked = button.getSelection();
				
				//Triggers a refresh in the Trace Part by settings the selected FileInfo in the SelectionService
				MPart part = partService.findPart(FilePart.ID);
				FilePart fileTreePart = (FilePart) part.getObject();
				final TreeViewer viewer = fileTreePart.getTreeViewer();
				viewer.getTree().setFocus();
				selectionService.setSelection(viewer.getSelection());
			}
		});
	}

	public boolean isChecked() {
		return checked;
	}
}