package com.perdemia.permissionanalyzer.application.jface.contentproviders;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.perdemia.permissionanalyzer.application.export.ExportHelper;
import com.perdemia.permissionanalyzer.application.export.FilterRow;
import com.perdemia.permissionanalyzer.application.export.ReportFilters;

/**
 * Content provider for the filterTreeViewer. It determines whether to show the FilterSets in the tree based in the presents of the FilterSets and the selected checkboxes in the GUI.
 * 
 * @author Reinier
 *
 */
public class ReportFilterContentProvider implements ITreeContentProvider {
	private ReportFilters reportFilters;
	
	@Override
	public void dispose() {}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		reportFilters = (ReportFilters) newInput;
	}

	@Override
	public Object[] getElements(Object inputElement) {		
		if (reportFilters != null) {
			return ExportHelper.determineFilterRows(reportFilters).toArray();
		} else {
			return null;
		}
	}

	@Override
	public Object[] getChildren(Object parentElement) {
		FilterRow filterRow = (FilterRow) parentElement;
		if (filterRow.getChildren() != null) {
			return filterRow.getChildren().toArray();
		} else {
			return null;
		}
	}

	@Override
	public Object getParent(Object element) {
		return null;
	}

	@Override
	public boolean hasChildren(Object element) {
		return ((FilterRow) element).getChildren() != null;
	}
}