package com.perdemia.permissionanalyzer.application.jface.dialogs;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.mihalis.opal.titledSeparator.TitledSeparator;

import com.perdemia.permissionanalyzer.application.util.Constants;
import com.perdemia.permissionanalyzer.application.util.ImageFactory;
import com.perdemia.permissionanalyzer.application.util.ImageFactory.AppImage;

public class HelpDialog extends DialogWithTopBar {
	
	public HelpDialog(Shell shell) {
		super(shell);
	}

	@Override
	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setImage(ImageFactory.getInstance().getImage(AppImage.HELP_16X16));
		shell.setSize(820, 830);
		shell.setText("Quick help");
	}
	
	@Override
	protected Control createDialogArea(Composite container) {
		Composite composite = (Composite) super.createDialogArea(container, "Quick help", ImageFactory.getInstance().getImage(AppImage.HELP_48X48));
		container.setBackgroundMode(SWT.INHERIT_DEFAULT);
				
		GridLayout gridLayout = new GridLayout(2, false);
		gridLayout.marginLeft = 30;
		gridLayout.marginRight = 20;
		composite.setLayout(gridLayout);
		
		TitledSeparator permissionSeparator = new TitledSeparator(composite, SWT.NONE);
		permissionSeparator.setData(Constants.CSS_CLASS_NAME_KEY, "dialog");
		permissionSeparator.setText("Permission indicators");
		permissionSeparator.setSize(50, 800);
		permissionSeparator.setBackgroundMode(SWT.INHERIT_FORCE);
		GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.horizontalSpan = 2;
		gridData.verticalIndent = 15;
		permissionSeparator.setLayoutData(gridData);
			
		CLabel permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("No permissions");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_NONE_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Read permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_READ_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("List folder content permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_LIST_FOLDER_CONTENT_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Read and Execute permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_EXECUTE_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Write permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_WRITE_20X20));
				
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Modify permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_MODIFY_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Delete permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_DELETE_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Full permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.FOLDER_FULL_20X20));
		
		TitledSeparator specialPermissionSeparator = new TitledSeparator(composite, SWT.NONE);
		specialPermissionSeparator.setData(Constants.CSS_CLASS_NAME_KEY, "dialog");
		specialPermissionSeparator.setText("Special permissions");
		specialPermissionSeparator.setSize(50, 800);
		gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.horizontalSpan = 2;
		gridData.verticalIndent = 15;
		specialPermissionSeparator.setLayoutData(gridData);
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Read data permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_READ_DATA_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Write data permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_WRITE_DATA_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Append data permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_APPEND_DATA_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Execute permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_EXECUTE_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Read attributes permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_READ_ATTR_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Write attributes permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_WRITE_ATTR_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Read extended attributes permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_READ_EXT_ATTR_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Write extended attributes permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_WRITE_EXT_ATTR_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Delete subfolders and files");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_DELETE_CHILD_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Delete permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_DELETE_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Read security info permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_READ_ACL_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Change security info permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_WRITE_ACL_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Take ownership permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.PERM_TAKE_OWNERSHIP_20X20));
		gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.horizontalSpan = 2;
		permissionsLabel.setLayoutData(gridData);
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Inherited Allow permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.INHERITED_ALLOW_20X20));
		gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.verticalIndent = 10;
		permissionsLabel.setLayoutData(gridData);
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Explicit Allow permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.EXPLICIT_ALLOW_20X20));
		gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.verticalIndent = 10;
		permissionsLabel.setLayoutData(gridData);
			
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Inherited Deny permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.INHERITED_DENY_20X20));
		
		permissionsLabel = new CLabel(composite, SWT.NONE);
		permissionsLabel.setText("Explicit Deny permission");
		permissionsLabel.setImage(ImageFactory.getInstance().getImage(AppImage.EXPLICIT_DENY_20X20));
		
		Label infoLabel = new Label(composite, SWT.NONE);
		infoLabel.setText("Tip: use the tooltip text on the special permissions in the folder tree to see the name.");
		gridData = new GridData(GridData.FILL_HORIZONTAL);
		gridData.horizontalSpan = 2;
		gridData.verticalIndent = 10;
		infoLabel.setLayoutData(gridData);
		
		return composite;
	}

	@Override
	protected void createButtonsForButtonBar(Composite parent) {		
		createButton(parent, IDialogConstants.CANCEL_ID, "Close", true);
	}
}
