package com.perdemia.permissionanalyzer.application.jface.labelproviders;

import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;

import com.perdemia.permissionanalyzer.application.util.ColorFactory;
import com.perdemia.permissionanalyzer.application.util.ColorFactory.AppColor;
import com.perdemia.permissionanalyzer.data.AclItem;
import com.perdemia.permissionanalyzer.data.FileInfo;

public class TotalOwnershipColumnLabelProvider extends ColumnLabelProvider {
	@Override
	public String getText(Object element) {
		if (element instanceof FileInfo) {
			FileInfo file = (FileInfo) element;
			if (file.getAllMembersOnFolder() > 0) {
				return GroupOwnershipColumnLabelProvider.OWNERSHIP_RATIO_FORMAT.format(((double)file.getAllMatchingMembersOnFolder() / (double)file.getAllMembersOnFolder() * 100)) + "%";
			} else {
				return "";
			}
		} else {
			return "Unknown type";
		}
	}
	
	@Override
	public Image getImage(Object element) {
		return null;
	}
	
	@Override
	public Color getForeground(Object element) {
		if (element instanceof FileInfo) {
			FileInfo file = (FileInfo) element;
			
			boolean allImplicit = true;
			if (file.getEffectivePermissions() != null) {
				for (AclItem aclItem : file.getEffectivePermissions().getPermissions().values()) {
					allImplicit = allImplicit && aclItem.isFlagInheritedAce();
				}
			}
			
			if (allImplicit) {
				return ColorFactory.getInstance().getColor(AppColor.GREY);
			}
		}
		
		return null;
	}
}