package com.perdemia.permissionanalyzer.application.logging;

import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.LogManager;

import org.eclipse.core.runtime.Platform;

/**
 * This special handler adds the path of the Eclipse application to the file pattern.
 * 
 * @author Reinier
 *
 */
public class PluginFileLogHandler extends FileHandler {

	public PluginFileLogHandler() throws IOException, SecurityException {
		//super(Platform.getLocation().toFile().getAbsolutePath() + filePattern, limit, count, append);
		super(Platform.getLocation().toFile().getAbsolutePath() + 
			LogManager.getLogManager().getProperty(PluginFileLogHandler.class.getName() + ".pattern"),
			Integer.parseInt(LogManager.getLogManager().getProperty(PluginFileLogHandler.class.getName() + ".limit").trim()),
			Integer.parseInt(LogManager.getLogManager().getProperty(PluginFileLogHandler.class.getName() + ".count").trim()),
			Boolean.parseBoolean(LogManager.getLogManager().getProperty(PluginFileLogHandler.class.getName() + ".append").trim()));
		
		System.out.println("Logging to file: " + Platform.getLocation().toFile().getAbsolutePath() + LogManager.getLogManager().getProperty(PluginFileLogHandler.class.getName() + ".pattern"));
	}
}
