package com.perdemia.permissionanalyzer.application.model;


public class LdapConnectionInfo {
	private int connectionId;
	private String connectionName;
	private String hostName;
	private int hostPort;
	private String username;
	private String password;
	private boolean onlyStorePasswordInMemory;
	
	private Encryption encryption;
	private Authentication authentication;
	
	// SASL / GSSAPI settings
	private boolean qualityOfProtectionAuthAllowed = true;
	private boolean qualityOfProtectionAuthIntAllowed = true;
	private boolean qualityOfProtectionAuthConfAllowed = true;
	private String realm;
	
	// GSSAPI settings
	private String configPath;
	private boolean useTicketCache = true;
	private String KDCAddress;
	
	public static enum Encryption {
		PLAIN, SSL, STARTTLS
	}
	
	public static enum Authentication {
		SIMPLE, DIGESTMD5, CRAMMD5, GSSAPI
	}
	
	public String getConnectionName() {
		return connectionName;
	}
	public void setConnectionName(String connectionName) {
		this.connectionName = connectionName;
	}
	public String getHostName() {
		return hostName;
	}
	public void setHostName(String hostName) {
		this.hostName = hostName;
	}
	public int getHostPort() {
		return hostPort;
	}
	public void setHostPort(int hostPort) {
		this.hostPort = hostPort;
	}
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	
	public int getConnectionId() {
		return connectionId;
	}
	public void setConnectionId(int connectionId) {
		this.connectionId = connectionId;
	}
	public Encryption getEncryption() {
		return encryption;
	}
	public void setEncryption(Encryption connectionType) {
		this.encryption = connectionType;
	}
	public Authentication getAuthentication() {
		return authentication;
	}
	public void setAuthentication(Authentication authentication) {
		this.authentication = authentication;
	}
	public boolean isQualityOfProtectionAuthAllowed() {
		return qualityOfProtectionAuthAllowed;
	}
	public void setQualityOfProtectionAuthAllowed(
			boolean qualityOfProtectionAuthAllowed) {
		this.qualityOfProtectionAuthAllowed = qualityOfProtectionAuthAllowed;
	}
	public boolean isQualityOfProtectionAuthIntAllowed() {
		return qualityOfProtectionAuthIntAllowed;
	}
	public void setQualityOfProtectionAuthIntAllowed(
			boolean qualityOfProtectionAuthIntAllowed) {
		this.qualityOfProtectionAuthIntAllowed = qualityOfProtectionAuthIntAllowed;
	}
	public boolean isQualityOfProtectionAuthConfAllowed() {
		return qualityOfProtectionAuthConfAllowed;
	}
	public void setQualityOfProtectionAuthConfAllowed(
			boolean qualityOfProtectionAuthConfAllowed) {
		this.qualityOfProtectionAuthConfAllowed = qualityOfProtectionAuthConfAllowed;
	}
	public String getRealm() {
		return realm;
	}
	public void setRealm(String realm) {
		this.realm = realm;
	}
	public String getConfigPath() {
		return configPath;
	}
	public void setConfigPath(String configPath) {
		this.configPath = configPath;
	}
	public boolean isUseTicketCache() {
		return useTicketCache;
	}
	public void setUseTicketCache(boolean useTicketCache) {
		this.useTicketCache = useTicketCache;
	}
	public String getKDCAddress() {
		return KDCAddress;
	}
	public void setKDCAddress(String kDCAddress) {
		KDCAddress = kDCAddress;
	}
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("LdapConnectionInfo [connectionId=");
		builder.append(connectionId);
		builder.append(", connectionName=");
		builder.append(connectionName);
		builder.append(", hostName=");
		builder.append(hostName);
		builder.append(", hostPort=");
		builder.append(hostPort);
		builder.append(", username=");
		builder.append(username);
		builder.append(", password=");
		builder.append("**********");
		builder.append(", encryption=");
		builder.append(encryption);
		builder.append(", authentication=");
		builder.append(authentication);
		builder.append(", qualityOfProtectionAuthAllowed=");
		builder.append(qualityOfProtectionAuthAllowed);
		builder.append(", qualityOfProtectionAuthIntAllowed=");
		builder.append(qualityOfProtectionAuthIntAllowed);
		builder.append(", qualityOfProtectionAuthConfAllowed=");
		builder.append(qualityOfProtectionAuthConfAllowed);
		builder.append(", realm=");
		builder.append(realm);
		builder.append(", configPath=");
		builder.append(configPath);
		builder.append(", useTicketCache=");
		builder.append(useTicketCache);
		builder.append(", KDCAddress=");
		builder.append(KDCAddress);
		builder.append("]");
		return builder.toString();
	}
	public boolean isOnlyStorePasswordInMemory() {
		return onlyStorePasswordInMemory;
	}
	public void setOnlyStorePasswordInMemory(boolean onlyStorePasswordInMemory) {
		this.onlyStorePasswordInMemory = onlyStorePasswordInMemory;
	}
}
