package com.perdemia.permissionanalyzer.application.model;

import com.perdemia.permissionanalyzer.data.ScanLogItem;


public interface StatusListener {
	public void newStatusMessage(ScanLogItem message);
	public void updateStatus(String message);
	public void directoryScanned(DirectoryInfo directory, boolean success);
	public void ldapOUScanned(LdapOUInfo ouInfo, boolean success);
	public boolean isCancelled();
	public void cancel();
	public void reset();
	public void proceed();
	public void directoriesScanned(int numberOfDirectories, int numberOfFiles);
	public void usersScanned(int numberOfUsers);
	public void groupsScanned(int numberOfGroups);
	public void nextStep();
	public int getNumberOfDirectories();
	public int getNumberOfFiles();
	public int getNumberOfUsers();
	public int getNumberOfGroups();
}
