package com.perdemia.permissionanalyzer.application.swt;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.Widget;

public class TreeViewerWithMonitor extends TreeViewer {
	private IProgressMonitor monitor;
	
	public TreeViewerWithMonitor(Composite parent) {
		super(parent);
	}

	public TreeViewerWithMonitor(Tree tree) {
		super(tree);
	}

	public TreeViewerWithMonitor(Composite parent, int style) {
		super(parent, style);
	}

	@Override
	protected void internalExpandToLevel(Widget widget, int level) {
		if (monitor == null || !monitor.isCanceled()) {
			super.internalExpandToLevel(widget, level);
		}
		if (monitor != null) {
			monitor.worked(1);
			Display.getCurrent().readAndDispatch();
		}
	}
	
	public IProgressMonitor getMonitor() {
		return monitor;
	}

	public void setMonitor(IProgressMonitor monitor) {
		this.monitor = monitor;
	}
}
