package com.perdemia.permissionanalyzer.application.swt;

import com.perdemia.permissionanalyzer.application.util.GraphicsUtils;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Label;

public class VerticalLabel {
	private Image image;
	private final Label label;
		
	public VerticalLabel (final Label label) {
		this.label = label;
				
		label.addPaintListener(new PaintListener(){
			@Override
			public void paintControl(PaintEvent e) {
				GridData gridData = (GridData) label.getLayoutData();
				int y = 0;
				if (gridData != null) {
					y = gridData.heightHint - 5;
				}
				e.gc.drawImage(image, 0, y-image.getImageData().height);				
			}
		});
	}

	public void setText(String string) {
		image = GraphicsUtils.createRotatedText(string, label.getFont(), label.getForeground(), label.getBackground(), SWT.UP);
	}
	
	public void setTooltip(String tooltip) {
		label.setToolTipText(tooltip);
	}	
}
