package com.perdemia.permissionanalyzer.scanner.ldap;

import java.security.GeneralSecurityException;
import java.util.List;

import com.perdemia.permissionanalyzer.application.model.LdapConnectionInfo;
import com.perdemia.permissionanalyzer.application.model.LdapOUInfo;
import com.perdemia.permissionanalyzer.application.model.StatusListener;
import com.perdemia.permissionanalyzer.data.LdapContainer;

import com.unboundid.ldap.sdk.LDAPException;

public interface LdapConnector {

	public abstract void openConnection(LdapConnectionInfo connection) throws LDAPException, GeneralSecurityException;

	public abstract void closeConnection();

	public abstract List<LdapContainer> getRootDNs() throws LDAPException;

	public abstract List<LdapContainer> getChildContainers(String parentDN) throws LDAPException;
	
	public abstract List<LdapContainer> searchContainers(String searchText) throws LDAPException;
	
	public abstract void testOU(LdapOUInfo ouInfo) throws LDAPException, GeneralSecurityException;
	
	public abstract void scanOUs(List<LdapOUInfo> ouInfoList, StatusListener statusListener);
}