package com.perdemia.permissionanalyzer.scanner.ldap;

import java.security.GeneralSecurityException;
import java.util.ArrayList;
import java.util.List;

import com.perdemia.permissionanalyzer.application.model.LdapConnectionInfo;
import com.perdemia.permissionanalyzer.application.model.LdapOUInfo;
import com.perdemia.permissionanalyzer.application.model.StatusListener;
import com.perdemia.permissionanalyzer.data.LdapContainer;

import com.unboundid.ldap.sdk.LDAPConnection;
import com.unboundid.ldap.sdk.LDAPException;
import com.unboundid.ldap.sdk.LDAPSearchException;

public final class LdapConnectorStub implements LdapConnector {
	LDAPConnection ldapConnection = null;

	/* (non-Javadoc)
	 * @see com.perdemia.permissionanalyzer.scanner.ldap.LdapConnector#closeConnection()
	 */
	@Override
	public void closeConnection() {
		System.out.println("Close LDAP connection in STUB");
	}

	/* (non-Javadoc)
	 * @see com.perdemia.permissionanalyzer.scanner.ldap.LdapConnector#getRootDNs()
	 */
	@Override
	public List<LdapContainer> getRootDNs() throws LDAPException {
		List<LdapContainer> result = new ArrayList<LdapContainer>();
		LdapContainer ldapContainer;

		for (int counter = 0; counter < 5; counter++) {
			ldapContainer = new LdapContainer();
			ldapContainer.setName("Root elem" + counter);
			ldapContainer.setDn("Root elem" + counter);
			result.add(ldapContainer);
		}

		return result;
	}

	/* (non-Javadoc)
	 * @see com.perdemia.permissionanalyzer.scanner.ldap.LdapConnector#getChildContainers(java.lang.String)
	 */
	@Override
	public List<LdapContainer> getChildContainers(String parentDN) throws LDAPSearchException {
		List<LdapContainer> result = new ArrayList<LdapContainer>();
		LdapContainer ldapContainer;
		for (int counter = 0; counter < 10; counter++) {
			ldapContainer = new LdapContainer();
			ldapContainer.setName("Name" + counter);
			ldapContainer.setDn(parentDN + ", DN" + counter);
			result.add(ldapContainer);
		}

		return result;
	}

	@Override
	public List<LdapContainer> searchContainers(String searchText) throws LDAPException {
		return getChildContainers(searchText);
	}

	@Override
	public void openConnection(LdapConnectionInfo connection)
			throws LDAPException, GeneralSecurityException {
		
	}

	@Override
	public void testOU(LdapOUInfo ouInfo) throws LDAPException,
			GeneralSecurityException {
		
	}

	@Override
	public void scanOUs(List<LdapOUInfo> ouInfoList,
			StatusListener statusListener) {		
	}
}
